# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 1.2.2.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::SQL
  module Models
    #
    # The server encryption protector.
    #
    class EncryptionProtector < ProxyResource

      include MsRestAzure

      include MsRest::JSONable
      # @return [Enum] Kind of encryption protector. This is metadata used for
      # the Azure portal experience. Possible values include: '',
      # 'azurekeyvault', 'servicemanaged'
      attr_accessor :kind

      # @return [String] Resource location.
      attr_accessor :location

      # @return [String] Subregion of the encryption protector.
      attr_accessor :subregion

      # @return [String] The name of the server key.
      attr_accessor :server_key_name

      # @return [ServerKeyType] The encryption protector type like
      # 'ServiceManaged', 'AzureKeyVault'. Possible values include:
      # 'ServiceManaged', 'AzureKeyVault'
      attr_accessor :server_key_type

      # @return [String] The URI of the server key.
      attr_accessor :uri

      # @return [String] Thumbprint of the server key.
      attr_accessor :thumbprint


      #
      # Mapper for EncryptionProtector class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          required: false,
          serialized_name: 'EncryptionProtector',
          type: {
            name: 'Composite',
            class_name: 'EncryptionProtector',
            model_properties: {
              id: {
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                required: false,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              location: {
                required: false,
                read_only: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              subregion: {
                required: false,
                read_only: true,
                serialized_name: 'properties.subregion',
                type: {
                  name: 'String'
                }
              },
              server_key_name: {
                required: false,
                serialized_name: 'properties.serverKeyName',
                type: {
                  name: 'String'
                }
              },
              server_key_type: {
                required: false,
                serialized_name: 'properties.serverKeyType',
                type: {
                  name: 'String'
                }
              },
              uri: {
                required: false,
                read_only: true,
                serialized_name: 'properties.uri',
                type: {
                  name: 'String'
                }
              },
              thumbprint: {
                required: false,
                read_only: true,
                serialized_name: 'properties.thumbprint',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
